<?
  session_start();

  // XML::MODUL   (Class CDesign)
  // XML::VERSION (0.020)
  // XML::AUTHOR  (::[CTH]Goldenhawk::)
  // XML::INFO    (Dieses Modul verwaltet das Layout der Intranetseite)


  // XML::COMMENT (Vesrion, Name und Autor festlege)
  $VERSION = "0.020";
  $NAME    = "CDesign";
  $AUTHOR  = "::[CTH]Goldenhawk::";

  // XML::COMMENT (Variablen laden)
  include_once("CConfig.php");
  include_once("CFunction.php");
  include_once("CModules.php");


  $cfunc = new CFunc;
  $cmod  = new CModules;
  global $cfunc,$cmod,$VERSION;

  // XML::COMMENT (Klasse festlegen)
  class CDesign
  {
    // XML::FUNC::getInfo ($self->getInfo())
    // XML::DESC::getInfo (liefert Name, Autor und Version des Modules zurck)
    // XML::VERSION::getInfo  (1.0)
    // XML::RETURN::getInfo ($NAME,$AUTHOR,$VERSION)
    function getInfo()
    {
      return $NAME;
      return $AUTHOR;
      return $VERSION;
    }

    // XML::FUNC::createSiteHeader ($self->createSiteHeader($opts))
    // XML::DESC::createSiteHeader (erstellt das Grundgerst der HTML-Seite)
    // XML::VERSION::createSiteHeader  (1.0)
	function createSiteHeader($opts)
	{
      global $cfunc;
	  $settings = $cfunc->getSettings();
	  $design = $this->getDesignSettings();

	  // XML::COMMENT (Metatags festlegen)
	  $html_metatags  = "    <meta http-equiv=\"content-language\" content=\"de\">\n";
	  $html_metatags .= "    <meta name=\"generator\" content=\"phpChrystal v".$settings['chrystal.version']."\">\n";
	  ($opts[pragma]) ? ($html_metatags .= "    <meta http-equiv=\"pragma\" content=\"no-cache\">\n") : ($dummy);
	  if ($opts[ref])
	  {
	    (!$opts[ref_time]) ? ($opts[ref_time] = "1") : ($dummy);
	    (!$opts[ref_addr]) ? ($opts[ref_addr] = $GLOBALS[HTTP_REFERER]) : ($dummy);

	    $html_metatags .= "  <meta http-equiv=\"refresh\" content=\"$opts[ref_time]; URL=$opts[ref_addr]\">\n\n";
	  }

	  // XML::COMMENT (Java,Javascripts etc. festlegen, die geladen werden sollen)
	  $html_java  = "    <script language=\"JavaScript\" src=\"scripts/vis_layer.js\"></script>\n";
	  $html_java .= "    <script language=\"JavaScript\" src=\"scripts/vis_text.js\"></script>\n";
	  $html_java .= "    <script language=\"JavaScript\" src=\"scripts/vis_img.js\"></script>\n";
	  $html_java .= "    <script language=\"JavaScript\" src=\"scripts/vis_bg.js\"></script>\n";
	  $html_java .= "    <script language=\"JavaScript\" src=\"scripts/func_window.js\"></script>\n";

	  // XML::COMMENT (Falls lan.javscript.shifts auf 1 gesetzt ist, kann man Dokumente mittels Shift+S absenden)
	  if ($settings['lan.javascript.shifts'])
	  {
	    $html_java .= "    <script language=\"JavaScript\" for=document event=\"onkeypress()\"  src=\"scripts/hotkey.js\"></script>\n";
	  }

	  // XML::COMMENT (StyleSheet festlegen)
	  ($design['use_template']) ? ($mytemplatedir = "templates/".$design['use_template']."/") : ($dummy);
	  ($design['use_template']) ? ($html_css = "    <link href=\"".$mytemplatedir."inner.css\" rel=stylesheet type=\"text/css\">\n") : ($html_css = "    <link href=\"style/inner.css\" rel=stylesheet type=\"text/css\">\n");

	  // XML::COMMENT (Titel festlegen)
	  (!$opts[titel]) ? ($html_titel = $settings['lan.ueberschrift']) : ($html_titel = $opts[titel]);

	  // XML::COMMENT (Nun die eigentliche Parsing-Routine)
	  // XML::COMMENT (es wird eine Template-Datei verwendet)
	  if ($design['use_template'])
	  {
		$my_tfheader = $mytemplatedir."my.header";

		$p_file = fopen($my_tfheader, "r");
		if ($p_file)
		{
		  $file = fread($p_file, filesize ($my_tfheader));

		  fclose ($p_file);

		  $file = preg_replace("/<!--XML::SITE::TITEL-->/i",$html_titel,$file);
		  $file = preg_replace("/<!--XML::SITE::CSS-->/i",$html_css,$file);
		  $file = preg_replace("/<!--XML::SITE::META-->/i",$html_metatags,$file);
		  $file = preg_replace("/<!--XML::SITE::JAVA-->/i",$html_java,$file);

		  print $file;
		}
	    else
	  	{
	  	  $cfunc->faultExt("Das Template $my_tfheader konnte nicht geffnet werden.");
	  	}
	  }
	  // XML::COMMENT (Falls keine Template-Datei vorhanden ist, bzw. keine benutzt werden soll (z.B. bei Erstinstallation))
	  else
	  {
	    print "<html>\n";
	    print "  <head>\n";
	    print "    <title>\n";
		print $html_titel;
	    print "    </title>\n\n";
	    print $html_metatags;
		print $html_java;
		print $html_css;
	    print "  </head>\n\n";
	    print "  <body>\n";
	  }
	}

    // XML::FUNC::createInnerTable ($self->createInnerTable($opts))
    // XML::DESC::createInnerTable (Erstellt die Tabelle mit den Texten etc.)
    // XML::VERSION::createInnerTable  (1.0)
	function createInnerTable($opts)
	{
	  print "    <div class=content>\n";
	  print "      <table class=content border=0 cellpadding=1 width=500 cellspacing=3>\n";
	}

    // XML::FUNC::createSiteLayers ($self->createSiteLayers($opts))
    // XML::DESC::createSiteLayers (Erstellt den Rumpf der Seite)
    // XML::VERSION::createSiteLayers  (1.0)
	function createSiteLayers($opts)
	{
      global $cfunc,$cmod;

	  // XML::COMMENT (linkes Banner festlegen)
	  (!$opts[banner_links]) ? ($html_banner = "      <img src=\"images/chrystal.jpg\">") : ($html_banner = "       <img src=\"".$opts[banner_links]."\">");

	  // XML::COMMENT (Navigationsleiste erstellen)
	  $design = $this->getDesignSettings();
	  $settings = $cfunc->getSettings();

	  $opts[onlyshowed] = "mainmenu";
	  $opts[onlyactive] = "1";
	  $mymod = $cmod->getMods($opts);

	  for ($cnt=0;$cnt<count($mymod);$cnt++)
	  {
	    // XML::COMMENT (berprfen, ob dieses Modul auf einen bestimmten Zustand abgestimmt ist)
	    if ((is_online && ($mymod[$cnt][online] == 0)) || (!is_online && ($mymod[$cnt][online] == 1)))
	    {
	      next;
	    }
		else
		{
		  // XML::COMMENT (Settings, Values aufsplitten)
		  $desset = split(";",$mymod[$cnt][settings]);
		  $desval = split(";",$mymod[$cnt][value]);

		  // XML::COMMENT (individuelle Einstellungen festlegen)
		  for ($cnt2=0;$cnt2<count($desset);$cnt2++)
		  {
		    $mymodset[$desset[$cnt2]] = $desval[$cnt2];
		  }

		  // XML::COMMENT (Das Trennzeichen wurde gendert)
		  ($mymodset[sepnormal] != '') ? ($my_link_sep_normal = $mymodset[sepnormal]) : ($my_link_sep_normal = $design['link.sep.normal']);
		  ($mymodset[seppre] != '') ? ($my_link_sep_pre = $mymodset[seppre]) : ($my_link_sep_pre = $design['link.sep.pre']);
		  ($mymodset[seppost] != '') ? ($my_link_sep_post = $mymodset[seppost]) : ($my_link_sep_post = $design['link.sep.post']);

		  // XML::COMMENT (Fr den Link wurde eine bestimmte Klasse gesetzt)
		  ($mymodset[linkclass]) ? ($my_link_class = "class=".$mymodset[linkclass]) : ($dummy);

		  // XML::COMMENT (Falls Flags gesetzt wurden, dass die Trennzeichen nicht sichtbar sein sollen)
		  ($mymodset[nopost]) ? ($my_link_sep_post = '') : ($my_link_sep_post);
		  ($mymodset[nopre]) ? ($my_link_sep_pre = '') : ($my_link_sep_pre);
	      ($mymodset[nosep]) ? ($my_link_sep_normal = '') : ($my_link_sep_normal);

		  $html_menu .= "      <a href=\"".$mymod[$cnt][url]."\" title=\"".$mymod[$cnt][desc]."\" $my_link_class>$my_link_sep_pre".$mymod[$cnt][showedname]."$my_link_sep_post</a>\n";
		  $html_menu .= "      $my_link_sep_normal\n";
		  unset($mymodset);
		}
	  }

	  // XML::COMMENT (Adminbox festlegen)
	  if (is_online)
	  {
  	    (session_is_registered("active_login")) ? ($html_adminbox = "      Eingeloggt als<br>$GLOBALS[active_username]\n<p><hr><p>      <a href=\"phpLogin.php?cmd=logout\">Logout</a>s\n") : ($html_adminbox = "      <a href=\"javascript:openWindow('phpHelp.php?cmd=help&id=login','Hilfe','300','400')\"><u>?</u></a>\n");
	  }
	  else
	  {
	    (session_is_registered("active_login")) ? ($html_adminbox = "      Eingeloggt als<br>$GLOBALS[active_username]\n<p><hr><p>      <a href=\"phpLogin.php?cmd=logout\">Logout</a>\n") : ($html_adminbox = "      Nicht eingeloggt\n");
	  }

	  // XML::COMMENT (Template-Dir festlegen)
	  ($design['use_template']) ? ($mytemplatedir = "templates/".$design['use_template']."/") : ($dummy);


	  // XML::COMMENT (Modul otf (on the fly) laden
	  include_once("CVoting.php");
	  $cvote = new CVoting;

	  // XML::COMMENT (Falls kein Template verwendet wird)
	  if (!$design['use_template'])
	  {
	    print "    <div class=banner>\n";
	    print "      &nbsp;\n";
	    print "    </div>\n\n";
        print "    <div class=banner_links>\n";
		print $html_banner;
        print "    </div>\n\n";
	    print "    <div class=navigat>\n";
		print $html_menu;
	    print "    </div>\n\n";
	    print "    <div class=voting>\n";
      	print $cvote->showVoting();
	    print "    </div>\n\n";
	    print "    <div class=quickinfo>\n";
	    print $cfunc->writeChrystalInfo();
	    print "    </div>\n\n";
	    print "    <div class=admin>\n";
	    print $html_adminbox;
	    print "    </div>\n\n";
	  }
	  // XML::COMMENT (es wird ein Template verwendet)
	  else
	  {
		$my_tfbody = $mytemplatedir."my.body";

		$p_file = fopen($my_tfbody, "r");
		if ($p_file)
		{
		  $file = fread($p_file, filesize ($my_tfbody));
		  fclose ($p_file);

		  $file = preg_replace("/<!--XML::SITE::ADMINBOX-->/i",$html_adminbox,$file);
		  $file = preg_replace("/<!--XML::SITE::NAVIGAT-->/i",$html_menu,$file);
		  $file = preg_replace("/<!--XML::SITE::MENU-->/i","$html_menu",$file);
		  $file = preg_replace("/<!--XML::SITE::H1-->/i","<h1>".$settings['lan.ueberschrift']."</h1>",$file);
		  $file = preg_replace("/<!--XML::SITE::BANNER::SUBMENU-->/i","$html_banner",$file);
		  $file = preg_replace("/<!--XML::SITE::BANNER::CHRYSTAL-->/i","<img src=\"images/chrystal-org.jpg\">",$file);
		  $file = preg_replace("/<!--XML::SITE::VOTING-->/i",$cvote->showVoting(),$file);
		  $file = preg_replace("/<!--XML::SITE::QUICKINFO-->/i",$cfunc->writeChrystalInfo(),$file);

		  print $file;
	    }
	    else
	  	{
	  	  $cfunc->faultExt("Das Template $my_tfbody konnte nicht geffnet werden.");
	  	}
	  }
	}

    // XML::FUNC::createAdminMenu ($self->createAdminMenu($opts))
    // XML::DESC::createAdminMenu (Erstellt das Administrationsmenu unter phpAdmin.php)
    // XML::VERSION::createAdminMenu  (1.0)
	// XML::VERSION::createAdminMenu ($string)
	function createAdminMenu($p_cl)
	{
	  include_once("CModules.php");
	  $cmod = new CModules;

	  $opts[onlyshowed] = "adminmenu";
	  $mymod = $cmod->getMods($opts);
	  $html = "      <ul>\n";

	  for($cnt=0;$cnt<count($mymod);$cnt++)
	  {
	    $html .= "        <li><a href=\"".$mymod[$cnt][uid]."?cmd=admin_overview\" title=\"".$mymod[$cnt][admindesc]."\">".$mymod[$cnt][adminname]."</a></li>\n";
	  }
	  // XML::COMMENT (Nun die Punkte anzeigen, die die phpAdmin.php inne hat und nicht registriert werden)
	  if (is_online)
      {
        $html .= "        <li><a href=\"phpAdmin.php?cmd=admin_newsletter\" title=\"Newsletter an LAN-Teilnehmer verfassen\">Newsletter verfassen</a>";
	  }
      $html .= "        <li><a href=\"phpLogin.php?cmd=show_logout\" class=normal title=\"Aus dem Intranet ausloggen\">Logout</a>";

	  if ($p_cl[p_return] == 'out')
	    print $html;
	  else
	    return $html;

	}

    // XML::FUNC::createUserMenu ($self->createUserMenu($opts))
    // XML::DESC::createUserMenu (Erstellt das Usermenu unter phpLoginn.php)
    // XML::VERSION::createUserMenu  (1.0)
	// XML::VERSION::createUserMenu ($string)
	function createUserMenu($opts)
	{
	  include_once("CModules.php");
	  $cmod = new CModules;

	  $opts[onlyshowed] = "usermenu";
	  $mymod = $cmod->getMods($opts);
	  $html = "      <ul>\n";

	  for($cnt=0;$cnt<count($mymod);$cnt++)
	  {
	    $html .= "        <li><a href=\"".$mymod[$cnt][uid]."?cmd=user_overview\" title=\"".$mymod[$cnt][desc]."\">".$mymod[$cnt][showedname]."</a></li>\n";
	  }
      $html .= "        <li><a href=\"phpLogin.php?cmd=show_logout\" class=normal title=\"Aus dem Intranet ausloggen\">Logout</a>";

	  $html .= "      </ul>\n";

	  if ($opts[p_return] == 'return')
	    return $html;
	  else
	    print $html;
	}

	// XML::FUNC::createSiteFooter ($self->createSiteFooter($opts))
    // XML::DESC::createSiteFooter (Erstellt den Fu der Seite)
    // XML::VERSION::createSiteFooter  (1.0)
	function createSiteFooter($opts)
	{
	  global $VERSION;
	  print "      </table>\n";
	  print "    </div>\n\n";
	  print "    <script language=\"JavaScript\" src=\"scripts/timer.js\"></script>\n";
	  print "    <script language=\"JavaScript\">window.setTimeout(\"ShowTime()\",100);</script>\n";
	  print "    <!-- This code was automatically generated  by phpChrystal CDesign v$VERSION.-->\n";
      print "    <!-- If you want to use CDesign for your site, please read the documentation of phpChrystal.-->\n";
      print "    <!-- More information about phpChrystal on chrystal.cyberwarnews.de-->\n";
	  print "  </body>\n";
	  print "</html>\n";
	}

    // XML::FUNC::createMenu ($self->createMenu($menu))
    // XML::DESC::createMenu (Erstellt Untermens z.B. fr die Administration)
    // XML::VERSION::createMenu  (1.0)
	// XML::RETURN::createMenu (BOOL)
	function createMenu($menu)
	{
	  // XML::COMMENT (Alle aktiven Module aus der Datenbank laden)

	  print "        <ul>\n";
	  for($cnt=0;$cnt<count($menu);$cnt++)
	  {
	    ($menu[$cnt][linkclass]) ? ($out_class = "class=".$menu[$cnt][linkclass]."") : ($dummy);
	    print "          <li><a href=\"".$menu[$cnt][link]."\" $out_class>".$menu[$cnt][showedname]."</a></li>\n";
	  }
	  print "        </ul>\n";

	  return true;
	}

    // XML::FUNC::createModulesMenu ($self->createModulesMenu())
    // XML::DESC::createModulesMenu (Erstellt Untermens fr den Adminbereich, falls type==admin=>Administration, sonst usermenu)
    // XML::VERSION::createModulesMenu  (1.0)
	// XML::RETURN::createModulesMenu (BOOL)
	function createModulesMenu($menu,$type)
	{
	  $i_total = count($menu);
	  $i_total--;

	  if ($type == 'admin')
	  {
	    print "        <a href=\"phpAdmin.php?cmd=show_login\" title=\"Administrationsbereich\">Administration</a> >";
	  }
	  elseif ($type == 'user')
	  {
	    print "        <a href=\"phpLogin.php?cmd=show_login\" title=\"Userbereich\">Userbereich</a> >";
	  }

	  for ($cnt=0;$cnt<count($menu);$cnt++)
	  {
	    // XML::COMMENT (Hier Routine einfgen, falls der Link dem aktiven Link entspricht)
	    // XML::CODE if ($cmd == $active)...
	    ($menu[$cnt][p_break]) ? ($sep = "<br>") : ($sep = "");
	     
	    print "        <a href=\"".$menu[$cnt][link]."\" title=\"".$menu[$cnt][showedname]."\">".$menu[$cnt][showedname]."</a> ";
		($cnt != $i_total) ? (print "| $sep") : (print "<p>");
	  }
	}

    // XML::FUNC::getDesignSettings ($self->getDesignSettings())
    // XML::DESC::getDesignSettings (Liest alle Designeinstellungen aus der Datenbank)
    // XML::VERSION::getDesignSettings  (1.0)
	// XML::RETURN::getDesignSettings ($array)
	function getDesignSettings()
	{
      $dbh = mysql_connect(mysql_server,mysql_root,mysql_pw) || $cfunc->faultMySQL();
      $dbs = mysql_select_db(mysql_database) || $cfunc->faultMySQL();
	  (!$dbh) ? ($cfunc->faultMySQL()) : ($dummy);

 	  $ar = array();
 	  $sth = mysql_query("SELECT setting, value FROM c_design");
 	  (!$sth) ? ($cfunc->faultMySQL()) : ($dummy);

	  while ($ret = mysql_fetch_row($sth))
	  {
	    $ar[$ret[0]] = $ret[1];
	  }

	  mysql_close();
	  return $ar;
	}

    // XML::FUNC::setDesignSetting ($self->setDesignSetting())
    // XML::DESC::setDesignSetting (Legt Einstellung fest)
    // XML::VERSION::setDesignSetting (1.0)
    function setDesignSetting($opts)
    {
      $dbh = mysql_connect(mysql_server,mysql_root,mysql_pw) || faultMySQL();
      $dbs = mysql_select_db(mysql_database) || faultMySQL();
	  (!$dbh) ? (faultMySQL()) : ($dummy);

 	  $sth = mysql_query("SELECT * FROM c_design WHERE setting=\"$opts[key]\"");
	  (!$sth) ? (faultMySQL()) : ($dummy);
   	  $ret = mysql_num_rows($sth);

	  if (!$opts['value'])
	  {
	    $opts['value'] = "";
  	  }

 	  if ($ret == 0)
 	  {
   	    if ($opts['increment'])
   	    {
   	      $opts['value'] = 1;
     	}

   	    $sth = mysql_query("INSERT INTO c_design VALUES(\"".$opts['key']."\",\"".$opts['value']."\")");
	    (!$sth) ? (faultMySQL()) : ($dummy);
  	  }
	  else
	  {
 	    if ($opts['increment'])
 	    {
 	      $sth = mysql_query("UPDATE c_design SET value=value+1 WHERE setting=\"$opts[key]\"");
 	      (!$sth) ? (faultMySQL()) : ($dummy);
	    }
 	    else
 	    {
 	      $sth = mysql_query("UPDATE c_design SET value=\"$opts[value]\" WHERE setting=\"$opts[key]\"");
 	      (!$sth) ? (faultMySQL()) : ($dummy);
	    }
	  }
	  mysql_close();
    }
  }

?>
