<?php 
  session_start();
  (!session_is_registered("active_login")) ? (exit) : ($dummy);
  include_once("./classes/CImExport.php");
  $cimexport = new CImExport;
  if ($cmd == 'do_export')
  {
    $out = $cimexport->export($table);
    print $out;
    exit;
  }
?>

<?
  // XML::MODUL   (phpAdmin)
  // XML::VERSION (0.020)
  // XML::AUTHOR  (::[CTH]Goldenhawk::)
  // XML::INFO    (phpAdmin exportiert die Datenbank und dient als Login-Portal fr den Administrationsbereich)


  // XML::COMMENT (Vesrion, Name und Autor festlege)
  $VERSION = "0.020";
  $NAME    = "phpImExport";
  $AUTHOR  = "::[CTH]Goldenhawk::";

  // XML::COMMENT (Variablen laden)
  include("./classes/CCore.php");

  // XML::COMMENT (Variablen fr das Modul festlegen)
  $opts[uid] 	    = "phpImExport.php";
  $opts[active] 	= 1;
  $opts[is_admin]   = 1;
  $opts[adminname]  = "XML-Im/Export";
  $opts[admindesc]  = "Datenbank im- und exportieren";

  // XML::COMMENT (Modul registrieren & $opts-Array lschen)
  $cmod->registerMod($opts);
  unset($opts);

  // XML::COMMENT (einzelne Menpunkte u.. festlegen)
  $menu = array();
  $menu[0][showedname] = "Anleitung";
  $menu[0][link] = "$PHP_SELF?cmd=admin_overview";
  if (is_online)
  {
    $menu[1][showedname] = "DB exportieren";
    $menu[1][link]       = "$PHP_SELF?cmd=do_export&table=user";
  }
  else
  {
    $menu[1][showedname] = "DB/Backup importieren";
    $menu[1][link]	   	 = "$PHP_SELF?cmd=admin_import";
    $menu[2][showedname] = "DB-Backup";
    $menu[2][link]	     = "$PHP_SELF?cmd=do_export&table=user";
  }
  global $menu;

  // XML::FUNC::getInfo ($self->getInfo())
  // XML::DESC::getInfo (liefert Name, Autor und Version des Modules zurck)
  // XML::VERSION::getInfo  (1.0)
  // XML::RETURN::getInfo ($NAME,$AUTHOR,$VERSION)
  function getInfo()
  {
    global $VERSION,$NAME,$AUTHOR;

    return $NAME;
    return $AUTHOR;
    return $VERSION;
  }
?>


<?php
  // XML::COMMENT (Grundgerst der HTML-Seite ausgeben)
  // XML::COMMENT (Falls ein Update der Einstellung durchgefhrt wurde, wird automatisch weitergeleitet)
  ((preg_match("/cmd_update/i",$cmd,$ret)) || (preg_match("/cmd_userupdate/i",$cmd,$ret))) ? (($opts[ref] = 1) && ($opts[reftime] = 2)) : ($opts[noopt]);

  // XML::COMMENT (Header,Titel etc. ausgeben)
  $cdesign->createSiteHeader($opts);

  // XML::COMMENT (Quickinfo etc. laden)
  $cdesign->createSiteLayers($opts);

  // XML::COMMENT (Falls Administrator eingeloggt ist und ein Administrationsbereich aufgerufen ist)
  if ((preg_match("/admin_/i",$cmd,$ret)) && session_is_registered("active_login"))
  {
    $opts[banner_links] = "images/adm.jpg";
	$cdesign->createModulesMenu($menu,"admin");
  }
  // XML::COMMENT (Layer und Tabelle mit den Haupttexten erstellen)
  $cdesign->createInnerTable($opts);
?>

<?php
  // XML::COMMENT (Datenbank in XML ausgeben)
  if ($cmd == 'admin_overview')
  {
	$p_cl[0][text]  = "Diese Plugin-In gibt dem Administrator die Mglichkeit\n";
	$p_cl[0][text] .= "<ul>\n<li>phpChrystal (online) nach XML zu exportieren\n";
	$p_cl[0][text] .= "<li>exportierte XML-Dateien (online) in die offline-Variante zu importieren\n";
	$p_cl[0][text] .= "<li>ein Backup wichtiger Tabellen nach XML zu machen\n";
	$p_cl[0][text] .= "<li>diese Backup nach einem phpChrystal-Update zu importieren\n";
	$p_cl[0][text] .= "</ul>\n";
	if (is_online)
	{
	  $p_cl[0][text] .= "Zum Export der Datenbank musst du oben im Menu auf \"DB exportieren\" mit der RECHTEN Maustaste klicken, dann
	  \"Speichern unter\" auswhlen und als Dateinamen \"export.xml\" angegeben.";
 	}
 	$cl->TableText($p_cl);
  }
  elseif ($cmd == 'admin_import')
  {
	$p_form[enctype] = "multipart/form-data";
	$p_form[action]  = "$PHP_SELF?cmd=admin_import";
	$cl->newForm($p_form);

	$p_cl[0][text] = "<input type=file name=in_file class=submit>";
	$cl->TableText($p_cl);

	$cl->FormSubmit(1,"Ausgewhlte XML-Datei importieren");

	if (isset($in_file))
	{
      // XML::COMMENT (Bugfix fr: http://www.securityfocus.com/archive/1/80106)
      if (isset($HTTP_COOKIE_VARS["in_file"]) || isset($HTTP_POST_VARS  ["in_file"]) || isset($HTTP_GET_VARS["in_file"]))
      {
        $cfunc->faultExt("Aus Sicherheitsgrnden wird der Upload abgebrochen.");
	  }
	  else
	  {
		$cimexport->import($in_file);

		$cl->cellDummy(1,"out");
  	    $p_cl[0][text] = "Die Datei $in_file_name wurde erfolgreich upgeloadet.";
    	$cl->TableText($p_cl);
      }
	}
  }
  // XML::COMMENT (Standard-Errorstring)
  else
  {
    faultExt("Diese String ist nicht registriert");
  }

?>

<?php
  // XML::COMMENT (Seite abschlieen)
  $cdesign->createSiteFooter($opts);
?>
