<?php session_start(); ?>

<?
  // XML::MODUL   (phpAdminSettings)
  // XML::VERSION (0.020)
  // XML::AUTHOR  (::[CTH]Goldenhawk::)
  // XML::INFO    (Dieses Plugin verwaltet alle Chrystal-Einstellungen)


  // XML::COMMENT (Vesrion, Name und Autor festlege)
  $VERSION = "0.020";
  $NAME    = "phpAdminSettings";
  $AUTHOR  = "::[CTH]Goldenhawk::";

  // XML::COMMENT (Variablen laden)
  include("./classes/CCore.php");

  // XML::COMMENT (Variablen fr das Modul festlegen)
  $opts[uid] 	    = "phpAdminSettings.php";
  $opts[active] 	= 1;
  $opts[online]     = 2;
  $opts[is_admin]   = 1;
  $opts[adminname]  = "Intranetoptionen";
  $opts[admindesc]  = "Einstellungen fr das Intranetsystem";

  // XML::COMMENT (Modul registrieren & $opts-Array lschen)
  $cmod->registerMod($opts);
  unset($opts);

  // XML::COMMENT (einzelne Menpunkte u.. festlegen)
  $menu = array();
  $menu[0][showedname] = "Generelle Einstellungen";
  $menu[0][link]       = "$PHP_SELF?cmd=admin_overview";
  $menu[1][showedname] = "Design";
  $menu[1][link]	   = "$PHP_SELF?cmd=admin_design";
  $menu[2][showedname] = "Templates";
  $menu[2][link]	   = "$PHP_SELF?cmd=admin_templates";
  global $menu;

  // XML::FUNC::getInfo ($self->getInfo())
  // XML::DESC::getInfo (liefert Name, Autor und Version des Modules zurck)
  // XML::VERSION::getInfo  (1.0)
  // XML::RETURN::getInfo ($NAME,$AUTHOR,$VERSION)
  function getInfo()
  {
    global $VERSION,$NAME,$AUTHOR;

    return $NAME;
    return $AUTHOR;
    return $VERSION;
  }
?>

<?php
  // XML::COMMENT (Grundgerst der HTML-Seite ausgeben)
  // XML::COMMENT (Falls ein Update der Einstellung durchgefhrt wurde, wird automatisch weitergeleitet)
  ((preg_match("/cmd_update/i",$cmd,$ret)) || (preg_match("/cmd_userupdate/i",$cmd,$ret))) ? (($opts[ref] = 1) && ($opts[reftime] = 2)) : ($opts[noopt]);

  // XML::COMMENT (Header,Titel etc. ausgeben)
  $cdesign->createSiteHeader($opts);

  // XML::COMMENT (Quickinfo etc. laden)
  $cdesign->createSiteLayers($opts);

  // XML::COMMENT (Falls Administrator eingeloggt ist und ein Administrationsbereich aufgerufen ist)
  if ((preg_match("/admin_/i",$cmd,$ret)) && session_is_registered("active_login"))
  {
    $opts[banner_links] = "images/adm.jpg";
	$cdesign->createModulesMenu($menu,"admin");
  }
  // XML::COMMENT (Layer und Tabelle mit den Haupttexten erstellen)
  $cdesign->createInnerTable($opts);
?>

<?php
  (!session_is_registered("active_login")) ? (faultExt("Du bist nicht befugt diese Ressource zu nutzen.")) : ($dummy);

  // XML::COMMENT (Chrystal-Einstellungen setzen anzeigen)
  if ($cmd == 'admin_overview')
  {
    $cl->FormNew("$PHP_SELF?cmd=cmd_update&what=general","");
	$cl->cells2Noopt("Termin der LAN","<input type=text name=in_termin value=\"".$settings['lan.termin']."\">","out");
	$cl->cells2Noopt("Maximale Teilnehmerzahl","<input type=text name=in_maxusers value=\"".$settings['lan.maxusers']."\" size=4>","out");
	$cl->cells2Noopt("berschrift","<input name=in_ueberschrift type=text value=\"".$settings['lan.ueberschrift']."\">","out");
	$cl->cells2Noopt("Erste verfgbare IP","<input name=in_ipstring type=text maxlength=11 size=11 value=\"".$settings['lan.ipstring']."\">.<input name=in_ipfirst maxsize=3 size=3 value=\"".$settings['lan.ipfirst']."\">","out");
	$cl->cells2Noopt("Allgemeine E-Mailadresse","<input name=in_email type=text value=\"".$settings['internet.email']."\">","out");

	($settings['lan.anmeldung.sendemail']) ? ($checked = "checked") : ($checked = "");
	$cl->cells2Noopt("E-Mail nach Onlineanmeldung verschicken","<input name=in_sendemail type=checkbox $checked value=\"".$settings['internet.anmeldung.sendemail']."\">","out");

	($settings['lan.javascript.shifts']) ? ($checked = "checked") : ($checked = "");
	$cl->cells2Noopt("Shift+S zum Absenden von Formularen aktivieren","<input name=in_shifts type=checkbox $checked value=\"1\">","out");

	$cl->FormSubmit("2","");
  }
  elseif ($cmd == 'admin_design')
  {
    $cl->FormNew("$PHP_SELF?cmd=cmd_update&what=design","");
  	$cl->cells2Noopt("Code zwischen Links","<input name=in_linksepnormal type=text value=\"".$design['link.sep.normal']."\">","out");
  	$cl->cells2Noopt("Code vor Linktext","<input name=in_linkseppre type=text value=\"".$design['link.sep.pre']."\">","out");
  	$cl->cells2Noopt("Code nach Linktext","<input name=in_linkseppost type=text value=\"".$design['link.sep.post']."\">","out");

	$cl->FormSubmit("2","");
  }
  elseif ($cmd == 'admin_templates')
  {
	if (!$dir)
	{
	  $p_cl[0][text] = "Template";
	  $p_cl[1][text] = "Informationen";
	  $cl->cellsTop($p_cl);

  	  // XML::COMMENT (Standard-Design an oberster Stelle einfgen)
  	  $cl->cells2Noopt("Standard","<a href=\"$PHP_SELF?cmd=admin_templates&dir=standard\">Informationen</a>","out");

	  $p_dir = opendir('./templates');
	  while ($file = readdir($p_dir))
	  {
        if ($file != "." && $file != "..")
        {
          if (is_dir("./templates/".$file))
          {
  	        $cl->cells2Noopt("$file","<a href=\"$PHP_SELF?cmd=admin_templates&dir=$file\">Informationen</a>","out");
          }
        }
	  }
	}
	else
	{
	  // XML::COMMENT (berprfen, welcher String bergeben wurde)
	  if (!($dir == 'standard'))
	  {
	    $file = "./templates/$dir/pref.xml";

	    $crax->openfile("$file");
	    $crax->record_delim = 'pref';
	    $crax->parse();
	    $rec = $crax->readRecord();

	    while ($rec)
	    {
          $row = $rec->getRow();
		  $my_desc = $row["desc"];
		  $my_url = $row["url_design"];
		  $my_author = $row["author"];
		  $my_normal = $row["sep_normal"];
		  $my_pre = $row["sep_pre"];
		  $my_post = $row["sep_post"];
		  $rec = $crax->readRecord();
	    }
		$my_normal = $cxml->proofString($my_normal);
        $cl->FormNew("$PHP_SELF?cmd=cmd_update&what=template&dir=$dir","");
  	    $cl->cells2Noopt("Beschreibung","$my_desc","out");
  	    $cl->cells2Noopt("Autor","$my_author","out");
  	    $cl->cells2Noopt("URL","$my_url","out");
  	    $cl->cells2Noopt("Separator zwischen Links","$my_normal","out");
	    $cl->FormHidden("in_linksepnormal","$my_normal");
  	    $cl->cells2Noopt("Separator vor Links","$my_pre","out");
	    $cl->FormHidden("in_linkseppre","$my_pre");
  	    $cl->cells2Noopt("Separator nach Links","$my_post","out");
	    $cl->FormHidden("in_linkseppost","$my_post");
	    $cl->FormSubmit("2","Template aktivieren");
  	  }
  	  else
  	  {
        $cl->FormNew("$PHP_SELF?cmd=cmd_update&what=template&dir=standard","");
  	    $cl->cells2Noopt("Beschreibung","Standard-Design","out");
  	    $cl->cells2Noopt("Autor","::[CTH]Goldenhawk:: & ::[CTH]Green::","out");
  	    $cl->cells2Noopt("URL","http://cth-con.cyberwarnews.de","out");
  	    $cl->cells2Noopt("Separator zwischen Links","|","out");
	    $cl->FormHidden("in_linksepnormal","|");
  	    $cl->cells2Noopt("Separator vor Links","","out");
	    $cl->FormHidden("in_linkseppre","");
  	    $cl->cells2Noopt("Separator nach Links","","out");
	    $cl->FormHidden("in_linkseppost","");
	    $cl->FormSubmit("2","Template aktivieren");
	  }
	}
  }
  // XML::COMMENT Chrystal-Einstellungen ausfhren
  elseif ($cmd == 'cmd_update')
  {
	if ($what == 'general')
	{
	  $opts = array(key=>"lan.ueberschrift",value=>$in_ueberschrift);
	  $cfunc->setSetting($opts);

	  $opts = array(key=>"lan.maxusers",value=>$in_maxusers);
	  $cfunc->setSetting($opts);

	  $opts = array(key=>"lan.termin",value=>$in_termin);
	  $cfunc->setSetting($opts);

	  $iptotal .= $in_ipstring.".".$in_ipfirst;

	  (!checkIPAddress($iptotal)) ? (faultExt("Die IP-Adresse besitzt kein gltiges Format.")) : ($dummy);
	  $opts = array(key=>"lan.ipstring",value=>$in_ipstring);
	  $cfunc->setSetting($opts);

	  $opts = array(key=>"lan.ipfirst",value=>$in_ipfirst);
	  $cfunc->setSetting($opts);

	  $opts = array(key=>"internet.email",value=>$in_email);
	  $cfunc->setSetting($opts);

	  $opts = array(key=>"lan.javascript.shifts",value=>$in_shifts);
	  $cfunc->setSetting($opts);
	}
    elseif ($what == 'design')
    {
      $opts = array(key=>"link.sep.normal",value=>$in_linksepnormal);
	  $cdesign->setDesignSetting($opts);

      $opts = array(key=>"link.sep.pre",value=>$in_linkseppre);
	  $cdesign->setDesignSetting($opts);

      $opts = array(key=>"link.sep.post",value=>$in_linkseppost);
	  $cdesign->setDesignSetting($opts);
	}
	elseif ($what == 'template')
	{
	  ($dir == 'standard') ? ($dir = '') : ($dummy);

      $opts = array(key=>"use_template",value=>$dir);
	  $cdesign->setDesignSetting($opts);

      $opts = array(key=>"link.sep.normal",value=>$in_linksepnormal);
	  $cdesign->setDesignSetting($opts);

      $opts = array(key=>"link.sep.pre",value=>$in_linkseppre);
	  $cdesign->setDesignSetting($opts);

      $opts = array(key=>"link.sep.post",value=>$in_linkseppost);
	  $cdesign->setDesignSetting($opts);
	}
	printDanke();
  }
  else
  {
    faultExt("Diese String ist nicht registriert");
  }

?>

<?php
  // XML::COMMENT (Seite abschlieen)
  $cdesign->createSiteFooter($opts);
?>
