<?php session_start(); ?>

<?
  // XML::MODUL   (phpTurnierAdmin)
  // XML::VERSION (0.020)
  // XML::AUTHOR  (::[CTH]Goldenhawk::)
  // XML::INFO    (Administrationsmodul fr Turnierverwaltung)


  // XML::COMMENT (Vesrion, Name und Autor festlege)
  $VERSION = "0.020";
  $NAME    = "phpTurnierAdmin";
  $AUTHOR  = "::[CTH]Goldenhawk::";

  // XML::COMMENT (Variablen laden)
   include("CCore.php");

  // XML::COMMENT (Variablen fr das Modul festlegen)
  $opts[uid] 	    = "phpTurnierAdmin.php";
  $opts[active] 	= 1;
  $opts[online]     = 0;
  $opts[is_admin]   = 1;
  $opts[adminname]  = "Turnierverwaltung";
  $opts[admindesc]  = "Turniere verwalten";

  // XML::COMMENT (Modul registrieren & $opts-Array lschen)
  $cmod->registerMod($opts);
  unset($opts);

  // XML::COMMENT (einzelne Menpunkte u.. festlegen)
  $menu = array();
  $menu[0][showedname] = "Neues Turnier";
  $menu[0][link]       = "$PHP_SELF?cmd=admin_overview";
  $menu[1][showedname] = "Turniere lschen";
  $menu[1][link]	   = "$PHP_SELF?cmd=admin_delete";
  $menu[2][showedname] = "Turniere Verwalten";
  $menu[2][link]	   = "$PHP_SELF?cmd=admin_change";
  global $menu;

  // XML::COMMENT (Spiele festlegen)
  $games = array("Counter-Strike","Day of Defeat","Return to Castle Wolfenstein","Quake3:Arena","UnrealTournament","Alien vs. Predator","Command & Conquer 3","Halo","StarCraft");
  global $games;

  // XML::COMMENT (Spiele festlegen)
  $teams = array("2","4","8","16","24","32","48","64");
  global $teams;

  // XML::COMMENT (Spieltypen festlegen)
  $types = array('single' => 'Single Elimination', 'double' => 'Double Elimination', '2lifes' => '2 Lifes');

  // XML::FUNC::getInfo ($self->getInfo())
  // XML::DESC::getInfo (liefert Name, Autor und Version des Modules zurck)
  // XML::VERSION::getInfo  (1.0)
  // XML::RETURN::getInfo ($NAME,$AUTHOR,$VERSION)
  function getInfo()
  {
    global $VERSION,$NAME,$AUTHOR;

    return $NAME;
    return $AUTHOR;
    return $VERSION;
  }
?>

<?php
  // XML::COMMENT (Grundgerst der HTML-Seite ausgeben)
  // XML::COMMENT (Falls ein Update der Einstellung durchgefhrt wurde, wird automatisch weitergeleitet)
  ((preg_match("/cmd_update/i",$cmd,$ret)) || (preg_match("/cmd_userupdate/i",$cmd,$ret))) ? (($opts[ref] = 1) && ($opts[reftime] = 2)) : ($opts[noopt]);

  // XML::COMMENT (Header,Titel etc. ausgeben)
  $cdesign->createSiteHeader($opts);

  // XML::COMMENT (Quickinfo etc. laden)
  $cdesign->createSiteLayers($opts);

  // XML::COMMENT (Falls Administrator eingeloggt ist und ein Administrationsbereich aufgerufen ist)
  if ((preg_match("/admin_/i",$cmd,$ret)) && session_is_registered("active_login"))
  {
    $opts[banner_links] = "images/adm.jpg";
	$cdesign->createModulesMenu($menu,"admin");
  }
  // XML::COMMENT (Layer und Tabelle mit den Haupttexten erstellen)
  $cdesign->createInnerTable($opts);
?>

<?php
  (!session_is_registered("active_login")) ? (faultExt("Du bist nicht befugt diese Ressource zu nutzen.")) : ($dummy);

  // XML::COMMENT (Turnier hinzufgen)
  if ($cmd == 'admin_overview')
  {
    $cl->FormNew("$PHP_SELF?cmd=cmd_update&what=add","");

	// XML::COMMENT (Server festlegen)
	$cl->cells2Noopt("Adresse des Game-Servers","<input type=text name=in_server>","out");

    // XML::COMMENT (Welches Spiel gespielt wird)
    for ($cnt = 0;$cnt<count($games);$cnt++)
    {
      $in .= "<option value=\"$games[$cnt]\">$games[$cnt]</option>\n";
	}
	$cl->cells2Noopt("Spiel","<select name=in_game>$in</select>","out");
	unset($in);

	$cl->cells2Noopt("Punktebewertung","<select name=in_rs><option value=\"asis\">Nach eingegebener Punktzahl</option><option value=\"soccer\">Bundesligabewertung</option></select>","out");

	// XML::COMMENT (Wieviel gegen wieviel => legt automatisch die Teamgre fest)
	for ($cnt = 1;$cnt<=16;$cnt++)
	{
	  $in .= "<option value=\"$cnt\">".$cnt."on".$cnt."</option>\n";
	}
	$cl->cells2Noopt("Konstellation","<select name=in_constellation>$in</select>\n","out");
	unset($in);

	// XML::COMMENT (Spielbeginn festlegen)
  	$date_nowhour = date("H");
  	$date_nowmin  = date("i");

	for ($cnt = 0;$cnt<=23;$cnt++)
	{
	  ($cnt == $date_nowhour) ? ($in = "selected") : ($in = "");
	  $in_1 .= "      <option value=\"$cnt\" $in>$cnt</option>\n";
	}

	for ($cnt = 0;$cnt<=59;$cnt++)
	{
	  ($cnt == $date_nowmin) ? ($in = "selected") : ($in = "");
	  $in_2 .= "      <option value=\"$cnt\" $in>$cnt</option>\n";
	}

	$cl->cells2Noopt("Turnierbeginn","<select name=in_start_hour>$in_1</select>:<select name=in_start_min>$in_2</select> Uhr","out");
	unset($in);

	// XML::COMMENT (Maximale Anzahl von Teams festlegen)
	for ($cnt = 0;$cnt<count($teams);$cnt++)
	{
	  $in .= "      <option value=\"$teams[$cnt]\">$teams[$cnt]</option>\n";
	}
	$cl->cells2Noopt("Max. Teams","<select name=in_max_teams>$in</select>","out");
	unset($in);

	// XML::COMMENT (Spieltypen festlegen)
	while(list($key,$val) = each($types))
	{
	  $in .= "      <option value=\"$key\">$val</option>\n";
	}
	$cl->cells2Noopt("Spieltyp","<select name=in_typ>$in</select>","out");
	unset($in);

	// XML::COMMENT (Spieltypen festlegen)
	$cl->cells2Noopt("Regelwerk (HTML erlaubt)","<textarea name=in_rules cols=40 rows=10></textarea>","out");
	unset($in);


	// XML::COMMENT (Nur Administrator darf Ergebnisse von Spielen eintragen)
	$cl->cells2Noopt("Nur Admin darf Spiele eintragen","<input type=checkbox name=in_only_admin value=1>","out");


	// XML::COMMENT (WWCL-Punktebewertung)
	$cl->cells2Noopt("Nach Beendigung WWCL-Ranking berechnen","<input type=checkbox name=in_wwcl value=1>","out");

    $cl->FormSubmit("2","Turnier erstellen");
  }
  elseif ($cmd == 'admin_delete')
  {
    $cl->FormNew("$PHP_SELF?cmd=cmd_update&what=delete","");
	$opts[noopt] = 1;

	$ar = $ctourn->getTourneys($opts);

	for($cnt = 0;$cnt<count($ar);$cnt++)
	{
	  $tset = $ctourn->getTSettings($ar[$cnt][tourneyid]);

	  $p_cl[0][text] = "<input type=checkbox name=in_todel[] value=".$ar[$cnt][id].">";
	  $p_cl[1][text] = $tset[game];
	  $p_cl[2][text] = $tset[constellation]."on".$tset[constellation];
	  $cl->TableText($p_cl);
	}
    $cl->FormSubmit("3","Ausgewhlte Turniere lschen");
  }
  elseif ($cmd == 'cmd_update')
  {
    if ($what == 'add')
    {
  	  $opts[gameserver]    = $in_server;
  	  $opts[game]		   = $in_game;
  	  $opts[constellation] = $in_constellation;
  	  $opts[starttime]	   = $in_start_hour.":".$in_start_min;
  	  $opts[max_teams]	   = $in_max_teams;
  	  $opts[rules]		   = $in_rules;
  	  $opts[sfoa]		   = $in_only_admin;
	  $opts[tourneytype]   = $in_typ;
	  $opts[rs]  		   = $in_rs;
	  $opts[wwcl]		   = $in_wwcl;
	  $ctourn->addTourney($opts);
	}
	elseif ($what == 'delete')
	{
	  $ctourn->deleteTourneys($in_todel);
	}
	printDanke();
  }
?>

<?php
  // XML::COMMENT (Seite abschlieen)
  $cdesign->createSiteFooter($opts);
?>
